//-----------------------------------------------------------
//    read_input.h
//-----------------------------------------------------------
#ifndef READ_INPUT
#define READ_INPUT
#include <cstddef>
#include <iostream>
#include <fstream>
#include "fem_app.h"
#include "sykes/value_type.h"

namespace test_stokes2d{
    void read_input(fem_app& _femapp, std::string const& _filename);
    
    std::istream& initialize_element_array_from_istream(
        std::istream& _ist,
        std::vector<fem_app::element_type>& _elarray,
        std::size_t _elsize);
        
    std::istream& initialize_node_array_from_istream(
        std::istream& _ist,
        std::vector<sykes::multi_carray<sykes::realnum, 2>>& _node_array,
        std::size_t _node_size);
    
    std::istream& initialize_material_array_from_istream(
        std::istream& _ist,
        std::vector<fem_app::material_type>& _mate_array,
        std::size_t _mate_size);
        
    std::istream& initialize_boundary_from_istream(
        std::istream& _ist,
        std::vector<sykes::fem::boundary::boundary_condition>& _bound,
        std::size_t _bound_size);
    
    void output_result(fem_app const& _femapp, std::string const& _filename);
    
    
    std::istream& getline_skip_comment(std::istream& inp1, std::string& str1);
    
    void split_string(std::string const& _str,
        std::vector<std::string>& _splited,
        std::string const& _delimiters = ", \t");
    
    bool is_whitespaces(std::string const& _str);
}//---- namespace fem_elastic2d
#endif

