#include "sykes/element/detail/eltype_tet.h"
#include "sykes/element/detail/tet_interpolation_functions.h"
#include "sykes/multi_carray.h"
#include "sykes/value_type.h"

namespace sykes{ namespace fem{ namespace element{
template<>
realnum calc_region_integral<eltype_tet<1>>(multi_carray<realnum, 4, 3> const& _nodepos)
{
    realnum v1 = (1.0 / 6.0) * (
        (_nodepos[3][0] - _nodepos[0][0]) * ((_nodepos[1][1] - _nodepos[0][1]) * (_nodepos[2][2] - _nodepos[0][2]) - (_nodepos[1][2] - _nodepos[0][2]) * (_nodepos[2][1] - _nodepos[0][1])) +
        (_nodepos[3][1] - _nodepos[0][1]) * ((_nodepos[1][2] - _nodepos[0][2]) * (_nodepos[2][0] - _nodepos[0][0]) - (_nodepos[1][0] - _nodepos[0][0]) * (_nodepos[2][2] - _nodepos[0][2])) +
        (_nodepos[3][2] - _nodepos[0][2]) * ((_nodepos[1][0] - _nodepos[0][0]) * (_nodepos[2][1] - _nodepos[0][1]) - (_nodepos[1][1] - _nodepos[0][1]) * (_nodepos[2][0] - _nodepos[0][0]))
        );
    return v1;
}

template<>
realnum calc_region_integral<eltype_tet<2>>(multi_carray<realnum, 10, 3> const& _nodepos)
{
    realnum v1 = (1.0 / 6.0) * (
        (_nodepos[3][0] - _nodepos[0][0]) * ((_nodepos[1][1] - _nodepos[0][1]) * (_nodepos[2][2] - _nodepos[0][2]) - (_nodepos[1][2] - _nodepos[0][2]) * (_nodepos[2][1] - _nodepos[0][1])) +
        (_nodepos[3][1] - _nodepos[0][1]) * ((_nodepos[1][2] - _nodepos[0][2]) * (_nodepos[2][0] - _nodepos[0][0]) - (_nodepos[1][0] - _nodepos[0][0]) * (_nodepos[2][2] - _nodepos[0][2])) +
        (_nodepos[3][2] - _nodepos[0][2]) * ((_nodepos[1][0] - _nodepos[0][0]) * (_nodepos[2][1] - _nodepos[0][1]) - (_nodepos[1][1] - _nodepos[0][1]) * (_nodepos[2][0] - _nodepos[0][0]))
        );
    return v1;
}

template<>
realnum calc_region_integral<eltype_tet<3>>(multi_carray<realnum, 20, 3> const& _nodepos)
{
    realnum v1 = (1.0 / 6.0) * (
        (_nodepos[3][0] - _nodepos[0][0]) * ((_nodepos[1][1] - _nodepos[0][1]) * (_nodepos[2][2] - _nodepos[0][2]) - (_nodepos[1][2] - _nodepos[0][2]) * (_nodepos[2][1] - _nodepos[0][1])) +
        (_nodepos[3][1] - _nodepos[0][1]) * ((_nodepos[1][2] - _nodepos[0][2]) * (_nodepos[2][0] - _nodepos[0][0]) - (_nodepos[1][0] - _nodepos[0][0]) * (_nodepos[2][2] - _nodepos[0][2])) +
        (_nodepos[3][2] - _nodepos[0][2]) * ((_nodepos[1][0] - _nodepos[0][0]) * (_nodepos[2][1] - _nodepos[0][1]) - (_nodepos[1][1] - _nodepos[0][1]) * (_nodepos[2][0] - _nodepos[0][0]))
        );
    return v1;
}

template<>
realnum calc_region_integral<eltype_tet<4>>(multi_carray<realnum, 35, 3> const& _nodepos)
{
    realnum v1 = (1.0 / 6.0) * (
        (_nodepos[3][0] - _nodepos[0][0]) * ((_nodepos[1][1] - _nodepos[0][1]) * (_nodepos[2][2] - _nodepos[0][2]) - (_nodepos[1][2] - _nodepos[0][2]) * (_nodepos[2][1] - _nodepos[0][1])) +
        (_nodepos[3][1] - _nodepos[0][1]) * ((_nodepos[1][2] - _nodepos[0][2]) * (_nodepos[2][0] - _nodepos[0][0]) - (_nodepos[1][0] - _nodepos[0][0]) * (_nodepos[2][2] - _nodepos[0][2])) +
        (_nodepos[3][2] - _nodepos[0][2]) * ((_nodepos[1][0] - _nodepos[0][0]) * (_nodepos[2][1] - _nodepos[0][1]) - (_nodepos[1][1] - _nodepos[0][1]) * (_nodepos[2][0] - _nodepos[0][0]))
        );
    return v1;
}

}}}//---- namespace element fem sykes
