#include "sykes/element/detail/eltype_tet.h"
#include "sykes/element/detail/tet_interpolation_functions.h"
#include "sykes/multi_carray.h"
#include "sykes/value_type.h"

namespace sykes{ namespace fem{ namespace element{
template<>
multi_carray<realnum, 4>
calc_region_integral_N<eltype_tet<1>>(multi_carray<realnum, 4, 3> const& _nodepos)
{
    realnum v1 = (1.0 / 6.0) * (
        (_nodepos[3][0] - _nodepos[0][0]) * ((_nodepos[1][1] - _nodepos[0][1]) * (_nodepos[2][2] - _nodepos[0][2]) - (_nodepos[1][2] - _nodepos[0][2]) * (_nodepos[2][1] - _nodepos[0][1])) +
        (_nodepos[3][1] - _nodepos[0][1]) * ((_nodepos[1][2] - _nodepos[0][2]) * (_nodepos[2][0] - _nodepos[0][0]) - (_nodepos[1][0] - _nodepos[0][0]) * (_nodepos[2][2] - _nodepos[0][2])) +
        (_nodepos[3][2] - _nodepos[0][2]) * ((_nodepos[1][0] - _nodepos[0][0]) * (_nodepos[2][1] - _nodepos[0][1]) - (_nodepos[1][1] - _nodepos[0][1]) * (_nodepos[2][0] - _nodepos[0][0]))
        );
	multi_carray<realnum, 4> I_N;
	I_N[0] = v1 * (  2.500000000000000e-01);
	I_N[1] = v1 * (  2.500000000000000e-01);
	I_N[2] = v1 * (  2.500000000000000e-01);
	I_N[3] = v1 * (  2.500000000000000e-01);
	return I_N;
}

template<>
multi_carray<realnum, 10>
calc_region_integral_N<eltype_tet<2>>(multi_carray<realnum, 10, 3> const& _nodepos)
{
    realnum v1 = (1.0 / 6.0) * (
        (_nodepos[3][0] - _nodepos[0][0]) * ((_nodepos[1][1] - _nodepos[0][1]) * (_nodepos[2][2] - _nodepos[0][2]) - (_nodepos[1][2] - _nodepos[0][2]) * (_nodepos[2][1] - _nodepos[0][1])) +
        (_nodepos[3][1] - _nodepos[0][1]) * ((_nodepos[1][2] - _nodepos[0][2]) * (_nodepos[2][0] - _nodepos[0][0]) - (_nodepos[1][0] - _nodepos[0][0]) * (_nodepos[2][2] - _nodepos[0][2])) +
        (_nodepos[3][2] - _nodepos[0][2]) * ((_nodepos[1][0] - _nodepos[0][0]) * (_nodepos[2][1] - _nodepos[0][1]) - (_nodepos[1][1] - _nodepos[0][1]) * (_nodepos[2][0] - _nodepos[0][0]))
        );
	multi_carray<realnum, 10> I_N;
	I_N[0] = v1 * ( -5.000000000000000e-02);
	I_N[1] = v1 * ( -5.000000000000000e-02);
	I_N[2] = v1 * ( -5.000000000000000e-02);
	I_N[3] = v1 * ( -5.000000000000000e-02);
	I_N[4] = v1 * (  2.000000000000000e-01);
	I_N[5] = v1 * (  2.000000000000000e-01);
	I_N[6] = v1 * (  2.000000000000000e-01);
	I_N[7] = v1 * (  2.000000000000000e-01);
	I_N[8] = v1 * (  2.000000000000000e-01);
	I_N[9] = v1 * (  2.000000000000000e-01);
	return I_N;
}

template<>
multi_carray<realnum, 20>
calc_region_integral_N<eltype_tet<3>>(multi_carray<realnum, 20, 3> const& _nodepos)
{
    realnum v1 = (1.0 / 6.0) * (
        (_nodepos[3][0] - _nodepos[0][0]) * ((_nodepos[1][1] - _nodepos[0][1]) * (_nodepos[2][2] - _nodepos[0][2]) - (_nodepos[1][2] - _nodepos[0][2]) * (_nodepos[2][1] - _nodepos[0][1])) +
        (_nodepos[3][1] - _nodepos[0][1]) * ((_nodepos[1][2] - _nodepos[0][2]) * (_nodepos[2][0] - _nodepos[0][0]) - (_nodepos[1][0] - _nodepos[0][0]) * (_nodepos[2][2] - _nodepos[0][2])) +
        (_nodepos[3][2] - _nodepos[0][2]) * ((_nodepos[1][0] - _nodepos[0][0]) * (_nodepos[2][1] - _nodepos[0][1]) - (_nodepos[1][1] - _nodepos[0][1]) * (_nodepos[2][0] - _nodepos[0][0]))
        );
	multi_carray<realnum, 20> I_N;
	I_N[0] = v1 * (  2.500000000000001e-02);
	I_N[1] = v1 * (  2.500000000000001e-02);
	I_N[2] = v1 * (  2.500000000000001e-02);
	I_N[3] = v1 * (  2.500000000000000e-02);
	I_N[4] = 0.0;
	I_N[5] = 0.0;
	I_N[6] = 0.0;
	I_N[7] = 0.0;
	I_N[8] = 0.0;
	I_N[9] = 0.0;
	I_N[10] = 0.0;
	I_N[11] = 0.0;
	I_N[12] = 0.0;
	I_N[13] = 0.0;
	I_N[14] = 0.0;
	I_N[15] = 0.0;
	I_N[16] = v1 * (  2.250000000000000e-01);
	I_N[17] = v1 * (  2.250000000000000e-01);
	I_N[18] = v1 * (  2.250000000000000e-01);
	I_N[19] = v1 * (  2.250000000000000e-01);
	return I_N;
}

template<>
multi_carray<realnum, 35>
calc_region_integral_N<eltype_tet<4>>(multi_carray<realnum, 35, 3> const& _nodepos)
{
    realnum v1 = (1.0 / 6.0) * (
        (_nodepos[3][0] - _nodepos[0][0]) * ((_nodepos[1][1] - _nodepos[0][1]) * (_nodepos[2][2] - _nodepos[0][2]) - (_nodepos[1][2] - _nodepos[0][2]) * (_nodepos[2][1] - _nodepos[0][1])) +
        (_nodepos[3][1] - _nodepos[0][1]) * ((_nodepos[1][2] - _nodepos[0][2]) * (_nodepos[2][0] - _nodepos[0][0]) - (_nodepos[1][0] - _nodepos[0][0]) * (_nodepos[2][2] - _nodepos[0][2])) +
        (_nodepos[3][2] - _nodepos[0][2]) * ((_nodepos[1][0] - _nodepos[0][0]) * (_nodepos[2][1] - _nodepos[0][1]) - (_nodepos[1][1] - _nodepos[0][1]) * (_nodepos[2][0] - _nodepos[0][0]))
        );
	multi_carray<realnum, 35> I_N;
	I_N[0] = v1 * ( -1.190476190476190e-02);
	I_N[1] = v1 * ( -1.190476190476190e-02);
	I_N[2] = v1 * ( -1.190476190476190e-02);
	I_N[3] = v1 * ( -1.190476190476190e-02);
	I_N[4] = v1 * (  3.809523809523810e-02);
	I_N[5] = v1 * ( -2.857142857142857e-02);
	I_N[6] = v1 * (  3.809523809523810e-02);
	I_N[7] = v1 * (  3.809523809523810e-02);
	I_N[8] = v1 * ( -2.857142857142857e-02);
	I_N[9] = v1 * (  3.809523809523810e-02);
	I_N[10] = v1 * (  3.809523809523810e-02);
	I_N[11] = v1 * ( -2.857142857142857e-02);
	I_N[12] = v1 * (  3.809523809523810e-02);
	I_N[13] = v1 * (  3.809523809523810e-02);
	I_N[14] = v1 * ( -2.857142857142857e-02);
	I_N[15] = v1 * (  3.809523809523810e-02);
	I_N[16] = v1 * (  3.809523809523810e-02);
	I_N[17] = v1 * ( -2.857142857142857e-02);
	I_N[18] = v1 * (  3.809523809523810e-02);
	I_N[19] = v1 * (  3.809523809523810e-02);
	I_N[20] = v1 * ( -2.857142857142857e-02);
	I_N[21] = v1 * (  3.809523809523810e-02);
	I_N[22] = v1 * (  3.809523809523810e-02);
	I_N[23] = v1 * (  3.809523809523810e-02);
	I_N[24] = v1 * (  3.809523809523810e-02);
	I_N[25] = v1 * (  3.809523809523810e-02);
	I_N[26] = v1 * (  3.809523809523810e-02);
	I_N[27] = v1 * (  3.809523809523810e-02);
	I_N[28] = v1 * (  3.809523809523810e-02);
	I_N[29] = v1 * (  3.809523809523810e-02);
	I_N[30] = v1 * (  3.809523809523810e-02);
	I_N[31] = v1 * (  3.809523809523810e-02);
	I_N[32] = v1 * (  3.809523809523810e-02);
	I_N[33] = v1 * (  3.809523809523810e-02);
	I_N[34] = v1 * (  3.047619047619048e-01);
	return I_N;
}

}}}//---- namespace element fem sykes

