#include "sykes/element/detail/eltype_tet.h"
#include "sykes/element/detail/tet_interpolation_functions.h"
#include "sykes/multi_carray.h"
#include "sykes/value_type.h"

namespace sykes{ namespace fem{ namespace element{
template<>
multi_carray<realnum, 4, 3>
calc_region_integral_dNdx<eltype_tet<1>>(multi_carray<realnum,4, 3> const& _nodepos)
{
    realnum m1[4][3];
    m1[0][0] =   _nodepos[1][1] * (_nodepos[3][2] - _nodepos[2][2])
               - _nodepos[2][1] * (_nodepos[3][2] - _nodepos[1][2])
               + _nodepos[3][1] * (_nodepos[2][2] - _nodepos[1][2]);
    m1[1][0] = - _nodepos[0][1] * (_nodepos[3][2] - _nodepos[2][2])
               + _nodepos[2][1] * (_nodepos[3][2] - _nodepos[0][2])
               - _nodepos[3][1] * (_nodepos[2][2] - _nodepos[0][2]);
    m1[2][0] =   _nodepos[0][1] * (_nodepos[3][2] - _nodepos[1][2])
               - _nodepos[1][1] * (_nodepos[3][2] - _nodepos[0][2])
               + _nodepos[3][1] * (_nodepos[1][2] - _nodepos[0][2]);
    m1[3][0] = - _nodepos[0][1] * (_nodepos[2][2] - _nodepos[1][2])
               + _nodepos[1][1] * (_nodepos[2][2] - _nodepos[0][2])
               - _nodepos[2][1] * (_nodepos[1][2] - _nodepos[0][2]);
    m1[0][1] =   _nodepos[1][2] * (_nodepos[3][0] - _nodepos[2][0])
               - _nodepos[2][2] * (_nodepos[3][0] - _nodepos[1][0])
               + _nodepos[3][2] * (_nodepos[2][0] - _nodepos[1][0]);
    m1[1][1] = - _nodepos[0][2] * (_nodepos[3][0] - _nodepos[2][0])
               + _nodepos[2][2] * (_nodepos[3][0] - _nodepos[0][0])
               - _nodepos[3][2] * (_nodepos[2][0] - _nodepos[0][0]);
    m1[2][1] = + _nodepos[0][2] * (_nodepos[3][0] - _nodepos[1][0])
               - _nodepos[1][2] * (_nodepos[3][0] - _nodepos[0][0])
               + _nodepos[3][2] * (_nodepos[1][0] - _nodepos[0][0]);
    m1[3][1] = - _nodepos[0][2] * (_nodepos[2][0] - _nodepos[1][0])
               + _nodepos[1][2] * (_nodepos[2][0] - _nodepos[0][0])
               - _nodepos[2][2] * (_nodepos[1][0] - _nodepos[0][0]);
    m1[0][2] =   _nodepos[1][0] * (_nodepos[3][1] - _nodepos[2][1])
               - _nodepos[2][0] * (_nodepos[3][1] - _nodepos[1][1])
               + _nodepos[3][0] * (_nodepos[2][1] - _nodepos[1][1]);
    m1[1][2] = - _nodepos[0][0] * (_nodepos[3][1] - _nodepos[2][1])
               + _nodepos[2][0] * (_nodepos[3][1] - _nodepos[0][1])
               - _nodepos[3][0] * (_nodepos[2][1] - _nodepos[0][1]);
    m1[2][2] =   _nodepos[0][0] * (_nodepos[3][1] - _nodepos[1][1])
               - _nodepos[1][0] * (_nodepos[3][1] - _nodepos[0][1])
               + _nodepos[3][0] * (_nodepos[1][1] - _nodepos[0][1]);
    m1[3][2] = - _nodepos[0][0] * (_nodepos[2][1] - _nodepos[1][1])
               + _nodepos[1][0] * (_nodepos[2][1] - _nodepos[0][1])
               - _nodepos[2][0] * (_nodepos[1][1] - _nodepos[0][1]);
    multi_carray<realnum, 4, 3> IdNdx;
    IdNdx[0][0] = (m1[0][0] * (  1.666666666666667e-01));
    IdNdx[0][1] = (m1[0][1] * (  1.666666666666667e-01));
    IdNdx[0][2] = (m1[0][2] * (  1.666666666666667e-01));
    IdNdx[1][0] = (m1[1][0] * (  1.666666666666667e-01));
    IdNdx[1][1] = (m1[1][1] * (  1.666666666666667e-01));
    IdNdx[1][2] = (m1[1][2] * (  1.666666666666667e-01));
    IdNdx[2][0] = (m1[2][0] * (  1.666666666666667e-01));
    IdNdx[2][1] = (m1[2][1] * (  1.666666666666667e-01));
    IdNdx[2][2] = (m1[2][2] * (  1.666666666666667e-01));
    IdNdx[3][0] = (m1[3][0] * (  1.666666666666667e-01));
    IdNdx[3][1] = (m1[3][1] * (  1.666666666666667e-01));
    IdNdx[3][2] = (m1[3][2] * (  1.666666666666667e-01));
    return IdNdx;
}

template<>
multi_carray<realnum, 10, 3>
calc_region_integral_dNdx<eltype_tet<2>>(multi_carray<realnum,10, 3> const& _nodepos)
{
    realnum m1[4][3];
    m1[0][0] =   _nodepos[1][1] * (_nodepos[3][2] - _nodepos[2][2])
               - _nodepos[2][1] * (_nodepos[3][2] - _nodepos[1][2])
               + _nodepos[3][1] * (_nodepos[2][2] - _nodepos[1][2]);
    m1[1][0] = - _nodepos[0][1] * (_nodepos[3][2] - _nodepos[2][2])
               + _nodepos[2][1] * (_nodepos[3][2] - _nodepos[0][2])
               - _nodepos[3][1] * (_nodepos[2][2] - _nodepos[0][2]);
    m1[2][0] =   _nodepos[0][1] * (_nodepos[3][2] - _nodepos[1][2])
               - _nodepos[1][1] * (_nodepos[3][2] - _nodepos[0][2])
               + _nodepos[3][1] * (_nodepos[1][2] - _nodepos[0][2]);
    m1[3][0] = - _nodepos[0][1] * (_nodepos[2][2] - _nodepos[1][2])
               + _nodepos[1][1] * (_nodepos[2][2] - _nodepos[0][2])
               - _nodepos[2][1] * (_nodepos[1][2] - _nodepos[0][2]);
    m1[0][1] =   _nodepos[1][2] * (_nodepos[3][0] - _nodepos[2][0])
               - _nodepos[2][2] * (_nodepos[3][0] - _nodepos[1][0])
               + _nodepos[3][2] * (_nodepos[2][0] - _nodepos[1][0]);
    m1[1][1] = - _nodepos[0][2] * (_nodepos[3][0] - _nodepos[2][0])
               + _nodepos[2][2] * (_nodepos[3][0] - _nodepos[0][0])
               - _nodepos[3][2] * (_nodepos[2][0] - _nodepos[0][0]);
    m1[2][1] = + _nodepos[0][2] * (_nodepos[3][0] - _nodepos[1][0])
               - _nodepos[1][2] * (_nodepos[3][0] - _nodepos[0][0])
               + _nodepos[3][2] * (_nodepos[1][0] - _nodepos[0][0]);
    m1[3][1] = - _nodepos[0][2] * (_nodepos[2][0] - _nodepos[1][0])
               + _nodepos[1][2] * (_nodepos[2][0] - _nodepos[0][0])
               - _nodepos[2][2] * (_nodepos[1][0] - _nodepos[0][0]);
    m1[0][2] =   _nodepos[1][0] * (_nodepos[3][1] - _nodepos[2][1])
               - _nodepos[2][0] * (_nodepos[3][1] - _nodepos[1][1])
               + _nodepos[3][0] * (_nodepos[2][1] - _nodepos[1][1]);
    m1[1][2] = - _nodepos[0][0] * (_nodepos[3][1] - _nodepos[2][1])
               + _nodepos[2][0] * (_nodepos[3][1] - _nodepos[0][1])
               - _nodepos[3][0] * (_nodepos[2][1] - _nodepos[0][1]);
    m1[2][2] =   _nodepos[0][0] * (_nodepos[3][1] - _nodepos[1][1])
               - _nodepos[1][0] * (_nodepos[3][1] - _nodepos[0][1])
               + _nodepos[3][0] * (_nodepos[1][1] - _nodepos[0][1]);
    m1[3][2] = - _nodepos[0][0] * (_nodepos[2][1] - _nodepos[1][1])
               + _nodepos[1][0] * (_nodepos[2][1] - _nodepos[0][1])
               - _nodepos[2][0] * (_nodepos[1][1] - _nodepos[0][1]);
    multi_carray<realnum, 10, 3> IdNdx;
    IdNdx[0][0] = 0.0;
    IdNdx[0][1] = 0.0;
    IdNdx[0][2] = 0.0;
    IdNdx[1][0] = 0.0;
    IdNdx[1][1] = 0.0;
    IdNdx[1][2] = 0.0;
    IdNdx[2][0] = 0.0;
    IdNdx[2][1] = 0.0;
    IdNdx[2][2] = 0.0;
    IdNdx[3][0] = 0.0;
    IdNdx[3][1] = 0.0;
    IdNdx[3][2] = 0.0;
    IdNdx[4][0] = (m1[0][0] * (  1.666666666666667e-01) + m1[1][0] * (  1.666666666666667e-01));
    IdNdx[4][1] = (m1[0][1] * (  1.666666666666667e-01) + m1[1][1] * (  1.666666666666667e-01));
    IdNdx[4][2] = (m1[0][2] * (  1.666666666666667e-01) + m1[1][2] * (  1.666666666666667e-01));
    IdNdx[5][0] = (m1[1][0] * (  1.666666666666667e-01) + m1[2][0] * (  1.666666666666667e-01));
    IdNdx[5][1] = (m1[1][1] * (  1.666666666666667e-01) + m1[2][1] * (  1.666666666666667e-01));
    IdNdx[5][2] = (m1[1][2] * (  1.666666666666667e-01) + m1[2][2] * (  1.666666666666667e-01));
    IdNdx[6][0] = (m1[0][0] * (  1.666666666666667e-01) + m1[2][0] * (  1.666666666666667e-01));
    IdNdx[6][1] = (m1[0][1] * (  1.666666666666667e-01) + m1[2][1] * (  1.666666666666667e-01));
    IdNdx[6][2] = (m1[0][2] * (  1.666666666666667e-01) + m1[2][2] * (  1.666666666666667e-01));
    IdNdx[7][0] = (m1[0][0] * (  1.666666666666667e-01) + m1[3][0] * (  1.666666666666667e-01));
    IdNdx[7][1] = (m1[0][1] * (  1.666666666666667e-01) + m1[3][1] * (  1.666666666666667e-01));
    IdNdx[7][2] = (m1[0][2] * (  1.666666666666667e-01) + m1[3][2] * (  1.666666666666667e-01));
    IdNdx[8][0] = (m1[2][0] * (  1.666666666666667e-01) + m1[3][0] * (  1.666666666666667e-01));
    IdNdx[8][1] = (m1[2][1] * (  1.666666666666667e-01) + m1[3][1] * (  1.666666666666667e-01));
    IdNdx[8][2] = (m1[2][2] * (  1.666666666666667e-01) + m1[3][2] * (  1.666666666666667e-01));
    IdNdx[9][0] = (m1[1][0] * (  1.666666666666667e-01) + m1[3][0] * (  1.666666666666667e-01));
    IdNdx[9][1] = (m1[1][1] * (  1.666666666666667e-01) + m1[3][1] * (  1.666666666666667e-01));
    IdNdx[9][2] = (m1[1][2] * (  1.666666666666667e-01) + m1[3][2] * (  1.666666666666667e-01));
    return IdNdx;
}

template<>
multi_carray<realnum, 20, 3>
calc_region_integral_dNdx<eltype_tet<3>>(multi_carray<realnum,20, 3> const& _nodepos)
{
    realnum m1[4][3];
    m1[0][0] =   _nodepos[1][1] * (_nodepos[3][2] - _nodepos[2][2])
               - _nodepos[2][1] * (_nodepos[3][2] - _nodepos[1][2])
               + _nodepos[3][1] * (_nodepos[2][2] - _nodepos[1][2]);
    m1[1][0] = - _nodepos[0][1] * (_nodepos[3][2] - _nodepos[2][2])
               + _nodepos[2][1] * (_nodepos[3][2] - _nodepos[0][2])
               - _nodepos[3][1] * (_nodepos[2][2] - _nodepos[0][2]);
    m1[2][0] =   _nodepos[0][1] * (_nodepos[3][2] - _nodepos[1][2])
               - _nodepos[1][1] * (_nodepos[3][2] - _nodepos[0][2])
               + _nodepos[3][1] * (_nodepos[1][2] - _nodepos[0][2]);
    m1[3][0] = - _nodepos[0][1] * (_nodepos[2][2] - _nodepos[1][2])
               + _nodepos[1][1] * (_nodepos[2][2] - _nodepos[0][2])
               - _nodepos[2][1] * (_nodepos[1][2] - _nodepos[0][2]);
    m1[0][1] =   _nodepos[1][2] * (_nodepos[3][0] - _nodepos[2][0])
               - _nodepos[2][2] * (_nodepos[3][0] - _nodepos[1][0])
               + _nodepos[3][2] * (_nodepos[2][0] - _nodepos[1][0]);
    m1[1][1] = - _nodepos[0][2] * (_nodepos[3][0] - _nodepos[2][0])
               + _nodepos[2][2] * (_nodepos[3][0] - _nodepos[0][0])
               - _nodepos[3][2] * (_nodepos[2][0] - _nodepos[0][0]);
    m1[2][1] = + _nodepos[0][2] * (_nodepos[3][0] - _nodepos[1][0])
               - _nodepos[1][2] * (_nodepos[3][0] - _nodepos[0][0])
               + _nodepos[3][2] * (_nodepos[1][0] - _nodepos[0][0]);
    m1[3][1] = - _nodepos[0][2] * (_nodepos[2][0] - _nodepos[1][0])
               + _nodepos[1][2] * (_nodepos[2][0] - _nodepos[0][0])
               - _nodepos[2][2] * (_nodepos[1][0] - _nodepos[0][0]);
    m1[0][2] =   _nodepos[1][0] * (_nodepos[3][1] - _nodepos[2][1])
               - _nodepos[2][0] * (_nodepos[3][1] - _nodepos[1][1])
               + _nodepos[3][0] * (_nodepos[2][1] - _nodepos[1][1]);
    m1[1][2] = - _nodepos[0][0] * (_nodepos[3][1] - _nodepos[2][1])
               + _nodepos[2][0] * (_nodepos[3][1] - _nodepos[0][1])
               - _nodepos[3][0] * (_nodepos[2][1] - _nodepos[0][1]);
    m1[2][2] =   _nodepos[0][0] * (_nodepos[3][1] - _nodepos[1][1])
               - _nodepos[1][0] * (_nodepos[3][1] - _nodepos[0][1])
               + _nodepos[3][0] * (_nodepos[1][1] - _nodepos[0][1]);
    m1[3][2] = - _nodepos[0][0] * (_nodepos[2][1] - _nodepos[1][1])
               + _nodepos[1][0] * (_nodepos[2][1] - _nodepos[0][1])
               - _nodepos[2][0] * (_nodepos[1][1] - _nodepos[0][1]);
    multi_carray<realnum, 20, 3> IdNdx;
    IdNdx[0][0] = (m1[0][0] * (  1.666666666666667e-02));
    IdNdx[0][1] = (m1[0][1] * (  1.666666666666667e-02));
    IdNdx[0][2] = (m1[0][2] * (  1.666666666666667e-02));
    IdNdx[1][0] = (m1[1][0] * (  1.666666666666667e-02));
    IdNdx[1][1] = (m1[1][1] * (  1.666666666666667e-02));
    IdNdx[1][2] = (m1[1][2] * (  1.666666666666667e-02));
    IdNdx[2][0] = (m1[2][0] * (  1.666666666666667e-02));
    IdNdx[2][1] = (m1[2][1] * (  1.666666666666667e-02));
    IdNdx[2][2] = (m1[2][2] * (  1.666666666666667e-02));
    IdNdx[3][0] = (m1[3][0] * (  1.666666666666667e-02));
    IdNdx[3][1] = (m1[3][1] * (  1.666666666666667e-02));
    IdNdx[3][2] = (m1[3][2] * (  1.666666666666667e-02));
    IdNdx[4][0] = (m1[0][0] * (  3.750000000000000e-02) + m1[1][0] * (  3.750000000000000e-02));
    IdNdx[4][1] = (m1[0][1] * (  3.750000000000000e-02) + m1[1][1] * (  3.750000000000000e-02));
    IdNdx[4][2] = (m1[0][2] * (  3.750000000000000e-02) + m1[1][2] * (  3.750000000000000e-02));
    IdNdx[5][0] = (m1[0][0] * (  3.750000000000000e-02) + m1[1][0] * (  3.750000000000000e-02));
    IdNdx[5][1] = (m1[0][1] * (  3.750000000000000e-02) + m1[1][1] * (  3.750000000000000e-02));
    IdNdx[5][2] = (m1[0][2] * (  3.750000000000000e-02) + m1[1][2] * (  3.750000000000000e-02));
    IdNdx[6][0] = (m1[1][0] * (  3.750000000000000e-02) + m1[2][0] * (  3.750000000000000e-02));
    IdNdx[6][1] = (m1[1][1] * (  3.750000000000000e-02) + m1[2][1] * (  3.750000000000000e-02));
    IdNdx[6][2] = (m1[1][2] * (  3.750000000000000e-02) + m1[2][2] * (  3.750000000000000e-02));
    IdNdx[7][0] = (m1[1][0] * (  3.750000000000000e-02) + m1[2][0] * (  3.750000000000000e-02));
    IdNdx[7][1] = (m1[1][1] * (  3.750000000000000e-02) + m1[2][1] * (  3.750000000000000e-02));
    IdNdx[7][2] = (m1[1][2] * (  3.750000000000000e-02) + m1[2][2] * (  3.750000000000000e-02));
    IdNdx[8][0] = (m1[0][0] * (  3.750000000000000e-02) + m1[2][0] * (  3.750000000000000e-02));
    IdNdx[8][1] = (m1[0][1] * (  3.750000000000000e-02) + m1[2][1] * (  3.750000000000000e-02));
    IdNdx[8][2] = (m1[0][2] * (  3.750000000000000e-02) + m1[2][2] * (  3.750000000000000e-02));
    IdNdx[9][0] = (m1[0][0] * (  3.750000000000000e-02) + m1[2][0] * (  3.750000000000000e-02));
    IdNdx[9][1] = (m1[0][1] * (  3.750000000000000e-02) + m1[2][1] * (  3.750000000000000e-02));
    IdNdx[9][2] = (m1[0][2] * (  3.750000000000000e-02) + m1[2][2] * (  3.750000000000000e-02));
    IdNdx[10][0] = (m1[0][0] * (  3.750000000000000e-02) + m1[3][0] * (  3.750000000000000e-02));
    IdNdx[10][1] = (m1[0][1] * (  3.750000000000000e-02) + m1[3][1] * (  3.750000000000000e-02));
    IdNdx[10][2] = (m1[0][2] * (  3.750000000000000e-02) + m1[3][2] * (  3.750000000000000e-02));
    IdNdx[11][0] = (m1[0][0] * (  3.750000000000000e-02) + m1[3][0] * (  3.750000000000000e-02));
    IdNdx[11][1] = (m1[0][1] * (  3.750000000000000e-02) + m1[3][1] * (  3.750000000000000e-02));
    IdNdx[11][2] = (m1[0][2] * (  3.750000000000000e-02) + m1[3][2] * (  3.750000000000000e-02));
    IdNdx[12][0] = (m1[2][0] * (  3.750000000000000e-02) + m1[3][0] * (  3.750000000000000e-02));
    IdNdx[12][1] = (m1[2][1] * (  3.750000000000000e-02) + m1[3][1] * (  3.750000000000000e-02));
    IdNdx[12][2] = (m1[2][2] * (  3.750000000000000e-02) + m1[3][2] * (  3.750000000000000e-02));
    IdNdx[13][0] = (m1[2][0] * (  3.750000000000000e-02) + m1[3][0] * (  3.750000000000000e-02));
    IdNdx[13][1] = (m1[2][1] * (  3.750000000000000e-02) + m1[3][1] * (  3.750000000000000e-02));
    IdNdx[13][2] = (m1[2][2] * (  3.750000000000000e-02) + m1[3][2] * (  3.750000000000000e-02));
    IdNdx[14][0] = (m1[1][0] * (  3.750000000000000e-02) + m1[3][0] * (  3.750000000000000e-02));
    IdNdx[14][1] = (m1[1][1] * (  3.750000000000000e-02) + m1[3][1] * (  3.750000000000000e-02));
    IdNdx[14][2] = (m1[1][2] * (  3.750000000000000e-02) + m1[3][2] * (  3.750000000000000e-02));
    IdNdx[15][0] = (m1[1][0] * (  3.750000000000000e-02) + m1[3][0] * (  3.750000000000000e-02));
    IdNdx[15][1] = (m1[1][1] * (  3.750000000000000e-02) + m1[3][1] * (  3.750000000000000e-02));
    IdNdx[15][2] = (m1[1][2] * (  3.750000000000000e-02) + m1[3][2] * (  3.750000000000000e-02));
    IdNdx[16][0] = (m1[3][0] * ( -2.250000000000000e-01));
    IdNdx[16][1] = (m1[3][1] * ( -2.250000000000000e-01));
    IdNdx[16][2] = (m1[3][2] * ( -2.250000000000000e-01));
    IdNdx[17][0] = (m1[2][0] * ( -2.250000000000000e-01));
    IdNdx[17][1] = (m1[2][1] * ( -2.250000000000000e-01));
    IdNdx[17][2] = (m1[2][2] * ( -2.250000000000000e-01));
    IdNdx[18][0] = (m1[1][0] * ( -2.250000000000000e-01));
    IdNdx[18][1] = (m1[1][1] * ( -2.250000000000000e-01));
    IdNdx[18][2] = (m1[1][2] * ( -2.250000000000000e-01));
    IdNdx[19][0] = (m1[0][0] * ( -2.250000000000000e-01));
    IdNdx[19][1] = (m1[0][1] * ( -2.250000000000000e-01));
    IdNdx[19][2] = (m1[0][2] * ( -2.250000000000000e-01));
    return IdNdx;
}

template<>
multi_carray<realnum, 35, 3>
calc_region_integral_dNdx<eltype_tet<4>>(multi_carray<realnum,35, 3> const& _nodepos)
{
    realnum m1[4][3];
    m1[0][0] =   _nodepos[1][1] * (_nodepos[3][2] - _nodepos[2][2])
               - _nodepos[2][1] * (_nodepos[3][2] - _nodepos[1][2])
               + _nodepos[3][1] * (_nodepos[2][2] - _nodepos[1][2]);
    m1[1][0] = - _nodepos[0][1] * (_nodepos[3][2] - _nodepos[2][2])
               + _nodepos[2][1] * (_nodepos[3][2] - _nodepos[0][2])
               - _nodepos[3][1] * (_nodepos[2][2] - _nodepos[0][2]);
    m1[2][0] =   _nodepos[0][1] * (_nodepos[3][2] - _nodepos[1][2])
               - _nodepos[1][1] * (_nodepos[3][2] - _nodepos[0][2])
               + _nodepos[3][1] * (_nodepos[1][2] - _nodepos[0][2]);
    m1[3][0] = - _nodepos[0][1] * (_nodepos[2][2] - _nodepos[1][2])
               + _nodepos[1][1] * (_nodepos[2][2] - _nodepos[0][2])
               - _nodepos[2][1] * (_nodepos[1][2] - _nodepos[0][2]);
    m1[0][1] =   _nodepos[1][2] * (_nodepos[3][0] - _nodepos[2][0])
               - _nodepos[2][2] * (_nodepos[3][0] - _nodepos[1][0])
               + _nodepos[3][2] * (_nodepos[2][0] - _nodepos[1][0]);
    m1[1][1] = - _nodepos[0][2] * (_nodepos[3][0] - _nodepos[2][0])
               + _nodepos[2][2] * (_nodepos[3][0] - _nodepos[0][0])
               - _nodepos[3][2] * (_nodepos[2][0] - _nodepos[0][0]);
    m1[2][1] = + _nodepos[0][2] * (_nodepos[3][0] - _nodepos[1][0])
               - _nodepos[1][2] * (_nodepos[3][0] - _nodepos[0][0])
               + _nodepos[3][2] * (_nodepos[1][0] - _nodepos[0][0]);
    m1[3][1] = - _nodepos[0][2] * (_nodepos[2][0] - _nodepos[1][0])
               + _nodepos[1][2] * (_nodepos[2][0] - _nodepos[0][0])
               - _nodepos[2][2] * (_nodepos[1][0] - _nodepos[0][0]);
    m1[0][2] =   _nodepos[1][0] * (_nodepos[3][1] - _nodepos[2][1])
               - _nodepos[2][0] * (_nodepos[3][1] - _nodepos[1][1])
               + _nodepos[3][0] * (_nodepos[2][1] - _nodepos[1][1]);
    m1[1][2] = - _nodepos[0][0] * (_nodepos[3][1] - _nodepos[2][1])
               + _nodepos[2][0] * (_nodepos[3][1] - _nodepos[0][1])
               - _nodepos[3][0] * (_nodepos[2][1] - _nodepos[0][1]);
    m1[2][2] =   _nodepos[0][0] * (_nodepos[3][1] - _nodepos[1][1])
               - _nodepos[1][0] * (_nodepos[3][1] - _nodepos[0][1])
               + _nodepos[3][0] * (_nodepos[1][1] - _nodepos[0][1]);
    m1[3][2] = - _nodepos[0][0] * (_nodepos[2][1] - _nodepos[1][1])
               + _nodepos[1][0] * (_nodepos[2][1] - _nodepos[0][1])
               - _nodepos[2][0] * (_nodepos[1][1] - _nodepos[0][1]);
    multi_carray<realnum, 35, 3> IdNdx;
    IdNdx[0][0] = 0.0;
    IdNdx[0][1] = 0.0;
    IdNdx[0][2] = 0.0;
    IdNdx[1][0] = 0.0;
    IdNdx[1][1] = 0.0;
    IdNdx[1][2] = 0.0;
    IdNdx[2][0] = 0.0;
    IdNdx[2][1] = 0.0;
    IdNdx[2][2] = 0.0;
    IdNdx[3][0] = 0.0;
    IdNdx[3][1] = 0.0;
    IdNdx[3][2] = 0.0;
    IdNdx[4][0] = (m1[0][0] * (  4.444444444444444e-02) + m1[1][0] * (  4.444444444444444e-02));
    IdNdx[4][1] = (m1[0][1] * (  4.444444444444444e-02) + m1[1][1] * (  4.444444444444444e-02));
    IdNdx[4][2] = (m1[0][2] * (  4.444444444444444e-02) + m1[1][2] * (  4.444444444444444e-02));
    IdNdx[5][0] = (m1[2][0] * (  1.111111111111111e-02) + m1[3][0] * (  1.111111111111111e-02));
    IdNdx[5][1] = (m1[2][1] * (  1.111111111111111e-02) + m1[3][1] * (  1.111111111111111e-02));
    IdNdx[5][2] = (m1[2][2] * (  1.111111111111111e-02) + m1[3][2] * (  1.111111111111111e-02));
    IdNdx[6][0] = (m1[0][0] * (  4.444444444444444e-02) + m1[1][0] * (  4.444444444444444e-02));
    IdNdx[6][1] = (m1[0][1] * (  4.444444444444444e-02) + m1[1][1] * (  4.444444444444444e-02));
    IdNdx[6][2] = (m1[0][2] * (  4.444444444444444e-02) + m1[1][2] * (  4.444444444444444e-02));
    IdNdx[7][0] = (m1[1][0] * (  4.444444444444444e-02) + m1[2][0] * (  4.444444444444444e-02));
    IdNdx[7][1] = (m1[1][1] * (  4.444444444444444e-02) + m1[2][1] * (  4.444444444444444e-02));
    IdNdx[7][2] = (m1[1][2] * (  4.444444444444444e-02) + m1[2][2] * (  4.444444444444444e-02));
    IdNdx[8][0] = (m1[0][0] * (  1.111111111111111e-02) + m1[3][0] * (  1.111111111111111e-02));
    IdNdx[8][1] = (m1[0][1] * (  1.111111111111111e-02) + m1[3][1] * (  1.111111111111111e-02));
    IdNdx[8][2] = (m1[0][2] * (  1.111111111111111e-02) + m1[3][2] * (  1.111111111111111e-02));
    IdNdx[9][0] = (m1[1][0] * (  4.444444444444444e-02) + m1[2][0] * (  4.444444444444444e-02));
    IdNdx[9][1] = (m1[1][1] * (  4.444444444444444e-02) + m1[2][1] * (  4.444444444444444e-02));
    IdNdx[9][2] = (m1[1][2] * (  4.444444444444444e-02) + m1[2][2] * (  4.444444444444444e-02));
    IdNdx[10][0] = (m1[0][0] * (  4.444444444444444e-02) + m1[2][0] * (  4.444444444444444e-02));
    IdNdx[10][1] = (m1[0][1] * (  4.444444444444444e-02) + m1[2][1] * (  4.444444444444444e-02));
    IdNdx[10][2] = (m1[0][2] * (  4.444444444444444e-02) + m1[2][2] * (  4.444444444444444e-02));
    IdNdx[11][0] = (m1[1][0] * (  1.111111111111111e-02) + m1[3][0] * (  1.111111111111111e-02));
    IdNdx[11][1] = (m1[1][1] * (  1.111111111111111e-02) + m1[3][1] * (  1.111111111111111e-02));
    IdNdx[11][2] = (m1[1][2] * (  1.111111111111111e-02) + m1[3][2] * (  1.111111111111111e-02));
    IdNdx[12][0] = (m1[0][0] * (  4.444444444444444e-02) + m1[2][0] * (  4.444444444444444e-02));
    IdNdx[12][1] = (m1[0][1] * (  4.444444444444444e-02) + m1[2][1] * (  4.444444444444444e-02));
    IdNdx[12][2] = (m1[0][2] * (  4.444444444444444e-02) + m1[2][2] * (  4.444444444444444e-02));
    IdNdx[13][0] = (m1[0][0] * (  4.444444444444444e-02) + m1[3][0] * (  4.444444444444444e-02));
    IdNdx[13][1] = (m1[0][1] * (  4.444444444444444e-02) + m1[3][1] * (  4.444444444444444e-02));
    IdNdx[13][2] = (m1[0][2] * (  4.444444444444444e-02) + m1[3][2] * (  4.444444444444444e-02));
    IdNdx[14][0] = (m1[1][0] * (  1.111111111111111e-02) + m1[2][0] * (  1.111111111111111e-02));
    IdNdx[14][1] = (m1[1][1] * (  1.111111111111111e-02) + m1[2][1] * (  1.111111111111111e-02));
    IdNdx[14][2] = (m1[1][2] * (  1.111111111111111e-02) + m1[2][2] * (  1.111111111111111e-02));
    IdNdx[15][0] = (m1[0][0] * (  4.444444444444444e-02) + m1[3][0] * (  4.444444444444444e-02));
    IdNdx[15][1] = (m1[0][1] * (  4.444444444444444e-02) + m1[3][1] * (  4.444444444444444e-02));
    IdNdx[15][2] = (m1[0][2] * (  4.444444444444444e-02) + m1[3][2] * (  4.444444444444444e-02));
    IdNdx[16][0] = (m1[2][0] * (  4.444444444444444e-02) + m1[3][0] * (  4.444444444444444e-02));
    IdNdx[16][1] = (m1[2][1] * (  4.444444444444444e-02) + m1[3][1] * (  4.444444444444444e-02));
    IdNdx[16][2] = (m1[2][2] * (  4.444444444444444e-02) + m1[3][2] * (  4.444444444444444e-02));
    IdNdx[17][0] = (m1[0][0] * (  1.111111111111111e-02) + m1[1][0] * (  1.111111111111111e-02));
    IdNdx[17][1] = (m1[0][1] * (  1.111111111111111e-02) + m1[1][1] * (  1.111111111111111e-02));
    IdNdx[17][2] = (m1[0][2] * (  1.111111111111111e-02) + m1[1][2] * (  1.111111111111111e-02));
    IdNdx[18][0] = (m1[2][0] * (  4.444444444444444e-02) + m1[3][0] * (  4.444444444444444e-02));
    IdNdx[18][1] = (m1[2][1] * (  4.444444444444444e-02) + m1[3][1] * (  4.444444444444444e-02));
    IdNdx[18][2] = (m1[2][2] * (  4.444444444444444e-02) + m1[3][2] * (  4.444444444444444e-02));
    IdNdx[19][0] = (m1[1][0] * (  4.444444444444444e-02) + m1[3][0] * (  4.444444444444444e-02));
    IdNdx[19][1] = (m1[1][1] * (  4.444444444444444e-02) + m1[3][1] * (  4.444444444444444e-02));
    IdNdx[19][2] = (m1[1][2] * (  4.444444444444444e-02) + m1[3][2] * (  4.444444444444444e-02));
    IdNdx[20][0] = (m1[0][0] * (  1.111111111111111e-02) + m1[2][0] * (  1.111111111111111e-02));
    IdNdx[20][1] = (m1[0][1] * (  1.111111111111111e-02) + m1[2][1] * (  1.111111111111111e-02));
    IdNdx[20][2] = (m1[0][2] * (  1.111111111111111e-02) + m1[2][2] * (  1.111111111111111e-02));
    IdNdx[21][0] = (m1[1][0] * (  4.444444444444444e-02) + m1[3][0] * (  4.444444444444444e-02));
    IdNdx[21][1] = (m1[1][1] * (  4.444444444444444e-02) + m1[3][1] * (  4.444444444444444e-02));
    IdNdx[21][2] = (m1[1][2] * (  4.444444444444444e-02) + m1[3][2] * (  4.444444444444444e-02));
    IdNdx[22][0] = (m1[3][0] * ( -8.888888888888889e-02));
    IdNdx[22][1] = (m1[3][1] * ( -8.888888888888889e-02));
    IdNdx[22][2] = (m1[3][2] * ( -8.888888888888889e-02));
    IdNdx[23][0] = (m1[3][0] * ( -8.888888888888889e-02));
    IdNdx[23][1] = (m1[3][1] * ( -8.888888888888889e-02));
    IdNdx[23][2] = (m1[3][2] * ( -8.888888888888889e-02));
    IdNdx[24][0] = (m1[3][0] * ( -8.888888888888889e-02));
    IdNdx[24][1] = (m1[3][1] * ( -8.888888888888889e-02));
    IdNdx[24][2] = (m1[3][2] * ( -8.888888888888889e-02));
    IdNdx[25][0] = (m1[2][0] * ( -8.888888888888889e-02));
    IdNdx[25][1] = (m1[2][1] * ( -8.888888888888889e-02));
    IdNdx[25][2] = (m1[2][2] * ( -8.888888888888889e-02));
    IdNdx[26][0] = (m1[2][0] * ( -8.888888888888889e-02));
    IdNdx[26][1] = (m1[2][1] * ( -8.888888888888889e-02));
    IdNdx[26][2] = (m1[2][2] * ( -8.888888888888889e-02));
    IdNdx[27][0] = (m1[2][0] * ( -8.888888888888889e-02));
    IdNdx[27][1] = (m1[2][1] * ( -8.888888888888889e-02));
    IdNdx[27][2] = (m1[2][2] * ( -8.888888888888889e-02));
    IdNdx[28][0] = (m1[1][0] * ( -8.888888888888889e-02));
    IdNdx[28][1] = (m1[1][1] * ( -8.888888888888889e-02));
    IdNdx[28][2] = (m1[1][2] * ( -8.888888888888889e-02));
    IdNdx[29][0] = (m1[1][0] * ( -8.888888888888889e-02));
    IdNdx[29][1] = (m1[1][1] * ( -8.888888888888889e-02));
    IdNdx[29][2] = (m1[1][2] * ( -8.888888888888889e-02));
    IdNdx[30][0] = (m1[1][0] * ( -8.888888888888889e-02));
    IdNdx[30][1] = (m1[1][1] * ( -8.888888888888889e-02));
    IdNdx[30][2] = (m1[1][2] * ( -8.888888888888889e-02));
    IdNdx[31][0] = (m1[0][0] * ( -8.888888888888889e-02));
    IdNdx[31][1] = (m1[0][1] * ( -8.888888888888889e-02));
    IdNdx[31][2] = (m1[0][2] * ( -8.888888888888889e-02));
    IdNdx[32][0] = (m1[0][0] * ( -8.888888888888889e-02));
    IdNdx[32][1] = (m1[0][1] * ( -8.888888888888889e-02));
    IdNdx[32][2] = (m1[0][2] * ( -8.888888888888889e-02));
    IdNdx[33][0] = (m1[0][0] * ( -8.888888888888889e-02));
    IdNdx[33][1] = (m1[0][1] * ( -8.888888888888889e-02));
    IdNdx[33][2] = (m1[0][2] * ( -8.888888888888889e-02));
    IdNdx[34][0] = 0.0;
    IdNdx[34][1] = 0.0;
    IdNdx[34][2] = 0.0;
    return IdNdx;
}

}}}//---- namespace element fem sykes

