#include "sykes/element/detail/eltype_tri.h"
#include "sykes/element/detail/tri_interpolation_functions.h"
#include "sykes/multi_carray.h"
#include "sykes/value_type.h"

namespace sykes{ namespace fem{ namespace element{

template<>
realnum calc_region_integral<eltype_tri<1>>(multi_carray<realnum, 3, 2> const& _nodepos)
{
    return (0.5 * (((_nodepos[1][0] - _nodepos[0][0]) * (_nodepos[2][1] - _nodepos[0][1])
     - (_nodepos[2][0] - _nodepos[0][0]) * (_nodepos[1][1] - _nodepos[0][1]))));
}

template<>
realnum calc_region_integral<eltype_tri<2>>(multi_carray<realnum, 6, 2> const& _nodepos)
{
    return (0.5 * (((_nodepos[1][0] - _nodepos[0][0]) * (_nodepos[2][1] - _nodepos[0][1])
     - (_nodepos[2][0] - _nodepos[0][0]) * (_nodepos[1][1] - _nodepos[0][1]))));
}

template<>
realnum calc_region_integral<eltype_tri<3>>(multi_carray<realnum, 10, 2> const& _nodepos)
{
    return (0.5 * (((_nodepos[1][0] - _nodepos[0][0]) * (_nodepos[2][1] - _nodepos[0][1])
     - (_nodepos[2][0] - _nodepos[0][0]) * (_nodepos[1][1] - _nodepos[0][1]))));
}

template<>
realnum calc_region_integral<eltype_tri<4>>(multi_carray<realnum, 15, 2> const& _nodepos)
{
    return (0.5 * (((_nodepos[1][0] - _nodepos[0][0]) * (_nodepos[2][1] - _nodepos[0][1])
     - (_nodepos[2][0] - _nodepos[0][0]) * (_nodepos[1][1] - _nodepos[0][1]))));
}

template<>
realnum calc_region_integral<eltype_tri<5>>(multi_carray<realnum, 21, 2> const& _nodepos)
{
    return (0.5 * (((_nodepos[1][0] - _nodepos[0][0]) * (_nodepos[2][1] - _nodepos[0][1])
     - (_nodepos[2][0] - _nodepos[0][0]) * (_nodepos[1][1] - _nodepos[0][1]))));
}

}}}//---- namespace element fem sykes

