#include "sykes/element/detail/eltype_tri.h"
#include "sykes/element/detail/tri_interpolation_functions.h"
#include "sykes/multi_carray.h"
#include "sykes/value_type.h"

namespace sykes{ namespace fem{ namespace element{
template<>
multi_carray<realnum, 3, 2>
calc_region_integral_dNdx<eltype_tri<1>>(multi_carray<realnum,3, 2> const& _nodepos)
{
    realnum m1[3][2] = {
        {(_nodepos[1][1] - _nodepos[2][1]), (_nodepos[2][0] - _nodepos[1][0])},
        {(_nodepos[2][1] - _nodepos[0][1]), (_nodepos[0][0] - _nodepos[2][0])},
        {(_nodepos[0][1] - _nodepos[1][1]), (_nodepos[1][0] - _nodepos[0][0])}};

    multi_carray<realnum, 3, 2> IdNdx;
    IdNdx[0][0] = (m1[0][0] * (  5.000000000000000e-01));
    IdNdx[0][1] = (m1[0][1] * (  5.000000000000000e-01));
    IdNdx[1][0] = (m1[1][0] * (  5.000000000000000e-01));
    IdNdx[1][1] = (m1[1][1] * (  5.000000000000000e-01));
    IdNdx[2][0] = (m1[2][0] * (  5.000000000000000e-01));
    IdNdx[2][1] = (m1[2][1] * (  5.000000000000000e-01));
    return IdNdx;
}

template<>
multi_carray<realnum, 6, 2>
calc_region_integral_dNdx<eltype_tri<2>>(multi_carray<realnum,6, 2> const& _nodepos)
{
    realnum m1[3][2] = {
        {(_nodepos[1][1] - _nodepos[2][1]), (_nodepos[2][0] - _nodepos[1][0])},
        {(_nodepos[2][1] - _nodepos[0][1]), (_nodepos[0][0] - _nodepos[2][0])},
        {(_nodepos[0][1] - _nodepos[1][1]), (_nodepos[1][0] - _nodepos[0][0])}};

    multi_carray<realnum, 6, 2> IdNdx;
    IdNdx[0][0] = (m1[0][0] * (  1.666666666666667e-01));
    IdNdx[0][1] = (m1[0][1] * (  1.666666666666667e-01));
    IdNdx[1][0] = (m1[1][0] * (  1.666666666666667e-01));
    IdNdx[1][1] = (m1[1][1] * (  1.666666666666667e-01));
    IdNdx[2][0] = (m1[2][0] * (  1.666666666666667e-01));
    IdNdx[2][1] = (m1[2][1] * (  1.666666666666667e-01));
    IdNdx[3][0] = (m1[2][0] * ( -6.666666666666667e-01));
    IdNdx[3][1] = (m1[2][1] * ( -6.666666666666667e-01));
    IdNdx[4][0] = (m1[0][0] * ( -6.666666666666667e-01));
    IdNdx[4][1] = (m1[0][1] * ( -6.666666666666667e-01));
    IdNdx[5][0] = (m1[1][0] * ( -6.666666666666667e-01));
    IdNdx[5][1] = (m1[1][1] * ( -6.666666666666667e-01));
    return IdNdx;
}

template<>
multi_carray<realnum, 10, 2>
calc_region_integral_dNdx<eltype_tri<3>>(multi_carray<realnum,10, 2> const& _nodepos)
{
    realnum m1[3][2] = {
        {(_nodepos[1][1] - _nodepos[2][1]), (_nodepos[2][0] - _nodepos[1][0])},
        {(_nodepos[2][1] - _nodepos[0][1]), (_nodepos[0][0] - _nodepos[2][0])},
        {(_nodepos[0][1] - _nodepos[1][1]), (_nodepos[1][0] - _nodepos[0][0])}};

    multi_carray<realnum, 10, 2> IdNdx;
    IdNdx[0][0] = (m1[0][0] * (  1.250000000000000e-01));
    IdNdx[0][1] = (m1[0][1] * (  1.250000000000000e-01));
    IdNdx[1][0] = (m1[1][0] * (  1.250000000000000e-01));
    IdNdx[1][1] = (m1[1][1] * (  1.250000000000000e-01));
    IdNdx[2][0] = (m1[2][0] * (  1.250000000000000e-01));
    IdNdx[2][1] = (m1[2][1] * (  1.250000000000000e-01));
    IdNdx[3][0] = (m1[2][0] * ( -3.750000000000000e-01));
    IdNdx[3][1] = (m1[2][1] * ( -3.750000000000000e-01));
    IdNdx[4][0] = (m1[2][0] * ( -3.750000000000000e-01));
    IdNdx[4][1] = (m1[2][1] * ( -3.750000000000000e-01));
    IdNdx[5][0] = (m1[0][0] * ( -3.750000000000000e-01));
    IdNdx[5][1] = (m1[0][1] * ( -3.750000000000000e-01));
    IdNdx[6][0] = (m1[0][0] * ( -3.750000000000000e-01));
    IdNdx[6][1] = (m1[0][1] * ( -3.750000000000000e-01));
    IdNdx[7][0] = (m1[1][0] * ( -3.750000000000000e-01));
    IdNdx[7][1] = (m1[1][1] * ( -3.750000000000000e-01));
    IdNdx[8][0] = (m1[1][0] * ( -3.750000000000000e-01));
    IdNdx[8][1] = (m1[1][1] * ( -3.750000000000000e-01));
    IdNdx[9][0] = 0.0;
    IdNdx[9][1] = 0.0;
    return IdNdx;
}

template<>
multi_carray<realnum, 15, 2>
calc_region_integral_dNdx<eltype_tri<4>>(multi_carray<realnum,15, 2> const& _nodepos)
{
    realnum m1[3][2] = {
        {(_nodepos[1][1] - _nodepos[2][1]), (_nodepos[2][0] - _nodepos[1][0])},
        {(_nodepos[2][1] - _nodepos[0][1]), (_nodepos[0][0] - _nodepos[2][0])},
        {(_nodepos[0][1] - _nodepos[1][1]), (_nodepos[1][0] - _nodepos[0][0])}};

    multi_carray<realnum, 15, 2> IdNdx;
    IdNdx[0][0] = (m1[0][0] * (  7.777777777777778e-02));
    IdNdx[0][1] = (m1[0][1] * (  7.777777777777778e-02));
    IdNdx[1][0] = (m1[1][0] * (  7.777777777777778e-02));
    IdNdx[1][1] = (m1[1][1] * (  7.777777777777778e-02));
    IdNdx[2][0] = (m1[2][0] * (  7.777777777777778e-02));
    IdNdx[2][1] = (m1[2][1] * (  7.777777777777778e-02));
    IdNdx[3][0] = (m1[2][0] * ( -3.555555555555556e-01));
    IdNdx[3][1] = (m1[2][1] * ( -3.555555555555556e-01));
    IdNdx[4][0] = (m1[2][0] * ( -1.333333333333333e-01));
    IdNdx[4][1] = (m1[2][1] * ( -1.333333333333333e-01));
    IdNdx[5][0] = (m1[2][0] * ( -3.555555555555556e-01));
    IdNdx[5][1] = (m1[2][1] * ( -3.555555555555556e-01));
    IdNdx[6][0] = (m1[0][0] * ( -3.555555555555556e-01));
    IdNdx[6][1] = (m1[0][1] * ( -3.555555555555556e-01));
    IdNdx[7][0] = (m1[0][0] * ( -1.333333333333333e-01));
    IdNdx[7][1] = (m1[0][1] * ( -1.333333333333333e-01));
    IdNdx[8][0] = (m1[0][0] * ( -3.555555555555556e-01));
    IdNdx[8][1] = (m1[0][1] * ( -3.555555555555556e-01));
    IdNdx[9][0] = (m1[1][0] * ( -3.555555555555556e-01));
    IdNdx[9][1] = (m1[1][1] * ( -3.555555555555556e-01));
    IdNdx[10][0] = (m1[1][0] * ( -1.333333333333333e-01));
    IdNdx[10][1] = (m1[1][1] * ( -1.333333333333333e-01));
    IdNdx[11][0] = (m1[1][0] * ( -3.555555555555556e-01));
    IdNdx[11][1] = (m1[1][1] * ( -3.555555555555556e-01));
    IdNdx[12][0] = 0.0;
    IdNdx[12][1] = 0.0;
    IdNdx[13][0] = 0.0;
    IdNdx[13][1] = 0.0;
    IdNdx[14][0] = 0.0;
    IdNdx[14][1] = 0.0;
    return IdNdx;
}

template<>
multi_carray<realnum, 21, 2>
calc_region_integral_dNdx<eltype_tri<5>>(multi_carray<realnum,21, 2> const& _nodepos)
{
    realnum m1[3][2] = {
        {(_nodepos[1][1] - _nodepos[2][1]), (_nodepos[2][0] - _nodepos[1][0])},
        {(_nodepos[2][1] - _nodepos[0][1]), (_nodepos[0][0] - _nodepos[2][0])},
        {(_nodepos[0][1] - _nodepos[1][1]), (_nodepos[1][0] - _nodepos[0][0])}};

    multi_carray<realnum, 21, 2> IdNdx;
    IdNdx[0][0] = (m1[0][0] * (  6.597222222222221e-02));
    IdNdx[0][1] = (m1[0][1] * (  6.597222222222221e-02));
    IdNdx[1][0] = (m1[1][0] * (  6.597222222222221e-02));
    IdNdx[1][1] = (m1[1][1] * (  6.597222222222221e-02));
    IdNdx[2][0] = (m1[2][0] * (  6.597222222222221e-02));
    IdNdx[2][1] = (m1[2][1] * (  6.597222222222221e-02));
    IdNdx[3][0] = (m1[2][0] * ( -2.604166666666666e-01));
    IdNdx[3][1] = (m1[2][1] * ( -2.604166666666666e-01));
    IdNdx[4][0] = (m1[2][0] * ( -1.736111111111111e-01));
    IdNdx[4][1] = (m1[2][1] * ( -1.736111111111111e-01));
    IdNdx[5][0] = (m1[2][0] * ( -1.736111111111111e-01));
    IdNdx[5][1] = (m1[2][1] * ( -1.736111111111111e-01));
    IdNdx[6][0] = (m1[2][0] * ( -2.604166666666666e-01));
    IdNdx[6][1] = (m1[2][1] * ( -2.604166666666666e-01));
    IdNdx[7][0] = (m1[0][0] * ( -2.604166666666666e-01));
    IdNdx[7][1] = (m1[0][1] * ( -2.604166666666666e-01));
    IdNdx[8][0] = (m1[0][0] * ( -1.736111111111110e-01));
    IdNdx[8][1] = (m1[0][1] * ( -1.736111111111110e-01));
    IdNdx[9][0] = (m1[0][0] * ( -1.736111111111110e-01));
    IdNdx[9][1] = (m1[0][1] * ( -1.736111111111110e-01));
    IdNdx[10][0] = (m1[0][0] * ( -2.604166666666666e-01));
    IdNdx[10][1] = (m1[0][1] * ( -2.604166666666666e-01));
    IdNdx[11][0] = (m1[1][0] * ( -2.604166666666666e-01));
    IdNdx[11][1] = (m1[1][1] * ( -2.604166666666666e-01));
    IdNdx[12][0] = (m1[1][0] * ( -1.736111111111110e-01));
    IdNdx[12][1] = (m1[1][1] * ( -1.736111111111110e-01));
    IdNdx[13][0] = (m1[1][0] * ( -1.736111111111110e-01));
    IdNdx[13][1] = (m1[1][1] * ( -1.736111111111110e-01));
    IdNdx[14][0] = (m1[1][0] * ( -2.604166666666666e-01));
    IdNdx[14][1] = (m1[1][1] * ( -2.604166666666666e-01));
    IdNdx[15][0] = 0.0;
    IdNdx[15][1] = 0.0;
    IdNdx[16][0] = 0.0;
    IdNdx[16][1] = 0.0;
    IdNdx[17][0] = 0.0;
    IdNdx[17][1] = 0.0;
    IdNdx[18][0] = 0.0;
    IdNdx[18][1] = 0.0;
    IdNdx[19][0] = 0.0;
    IdNdx[19][1] = 0.0;
    IdNdx[20][0] = 0.0;
    IdNdx[20][1] = 0.0;
    return IdNdx;
}

}}}//---- namespace element fem sykes

