//-----------------------------------------------------------
//    interpolation_functions.h
//-----------------------------------------------------------
#ifndef SYKES_ELEMENT_DETAIL_INTERPOLATION_FUNCTIONS
#define SYKES_ELEMENT_DETAIL_INTERPOLATION_FUNCTIONS

#include "sykes/multi_carray.h"
#include "sykes/value_type.h"
#include <type_traits>

namespace sykes{ namespace fem{ namespace element{
    
    template<typename Eltype>
    realnum calc_region_integral(multi_carray<realnum, Eltype::node_size, Eltype::dim> const& _nodepos);
    
    template<typename Eltype>
    multi_carray<realnum, Eltype::node_size>
    calc_region_integral_N(multi_carray<realnum, Eltype::node_size, Eltype::dim> const& _nodepos);
    
    template<typename Eltype>
    multi_carray<realnum, Eltype::node_size, Eltype::dim>
    calc_region_integral_dNdx(multi_carray<realnum, Eltype::node_size, Eltype::dim> const& _nodepos);
    
    template<typename Eltype>
    multi_carray<realnum, Eltype::node_size, Eltype::node_size, Eltype::dim, Eltype::dim>
    calc_region_integral_dNdx_dNdx(multi_carray<realnum, Eltype::node_size, Eltype::dim> const& _nodepos);
    
    template<typename Eltype1, typename Eltype2>
    multi_carray<realnum, Eltype1::node_size, Eltype2::node_size, Eltype1::dim>
    calc_region_integral_dNdx_L(
        multi_carray<realnum, Eltype1::node_size, Eltype1::dim> const& _nodepos1,
        multi_carray<
            typename std::enable_if<
                (Eltype1::order > Eltype2::order),
                realnum
            >::type,
            Eltype2::node_size, Eltype2::dim> const& _nodepos2);
    
}}}//---- namespace tri element fem sykes
#endif

