//-----------------------------------------------------------
//    tet_interpolation_functions.h
//-----------------------------------------------------------
#ifndef SYKES_ELEMENT_TET_INTERPOLATION_FUNCTIONS
#define SYKES_ELEMENT_TET_INTERPOLATION_FUNCTIONS
#include "sykes/element/detail/eltype_tet.h"
#include "sykes/element/detail/interpolation_functions.h"
#include <tuple>

namespace sykes{ namespace fem{ namespace element{

    template<>
    realnum
    calc_region_integral<eltype_tet<1>>(multi_carray<realnum, 4, 3> const& _nodepos);

    template<>
    realnum
    calc_region_integral<eltype_tet<2>>(multi_carray<realnum, 10, 3> const& _nodepos);

    template<>
    realnum
    calc_region_integral<eltype_tet<3>>(multi_carray<realnum, 20, 3> const& _nodepos);

    template<>
    realnum
    calc_region_integral<eltype_tet<4>>(multi_carray<realnum, 35, 3> const& _nodepos);

    template<>
    multi_carray<realnum, 4>
    calc_region_integral_N<eltype_tet<1>>(multi_carray<realnum, 4, 3> const& _nodepos);

    template<>
    multi_carray<realnum, 10>
    calc_region_integral_N<eltype_tet<2>>(multi_carray<realnum, 10, 3> const& _nodepos);

    template<>
    multi_carray<realnum, 20>
    calc_region_integral_N<eltype_tet<3>>(multi_carray<realnum, 20, 3> const& _nodepos);

    template<>
    multi_carray<realnum, 35>
    calc_region_integral_N<eltype_tet<4>>(multi_carray<realnum, 35, 3> const& _nodepos);

    template<>
    multi_carray<realnum, 4, 4, 3, 3>
    calc_region_integral_dNdx_dNdx<eltype_tet<1>>(multi_carray<realnum, 4, 3> const& _nodepos);

    template<>
    multi_carray<realnum, 10, 10, 3, 3>
    calc_region_integral_dNdx_dNdx<eltype_tet<2>>(multi_carray<realnum, 10, 3> const& _nodepos);

    template<>
    multi_carray<realnum, 20, 20, 3, 3>
    calc_region_integral_dNdx_dNdx<eltype_tet<3>>(multi_carray<realnum, 20, 3> const& _nodepos);

    template<>
    multi_carray<realnum, 35, 35, 3, 3>
    calc_region_integral_dNdx_dNdx<eltype_tet<4>>(multi_carray<realnum, 35, 3> const& _nodepos);

    template<>
    multi_carray<realnum, 10, 4, 3>
    calc_region_integral_dNdx_L<eltype_tet<2>, eltype_tet<1>>(
        multi_carray<realnum, 10, 3> const& _nodepos1,
        multi_carray<realnum, 4, 3> const& _nodepos2);

    template<>
    multi_carray<realnum, 20, 4, 3>
    calc_region_integral_dNdx_L<eltype_tet<3>, eltype_tet<1>>(
        multi_carray<realnum, 20, 3> const& _nodepos1,
        multi_carray<realnum, 4, 3> const& _nodepos2);

    template<>
    multi_carray<realnum, 20, 10, 3>
    calc_region_integral_dNdx_L<eltype_tet<3>, eltype_tet<2>>(
        multi_carray<realnum, 20, 3> const& _nodepos1,
        multi_carray<realnum, 10, 3> const& _nodepos2);

    template<>
    multi_carray<realnum, 35, 4, 3>
    calc_region_integral_dNdx_L<eltype_tet<4>, eltype_tet<1>>(
        multi_carray<realnum, 35, 3> const& _nodepos1,
        multi_carray<realnum, 4, 3> const& _nodepos2);

    template<>
    multi_carray<realnum, 35, 10, 3>
    calc_region_integral_dNdx_L<eltype_tet<4>, eltype_tet<2>>(
        multi_carray<realnum, 35, 3> const& _nodepos1,
        multi_carray<realnum, 10, 3> const& _nodepos2);

    template<>
    multi_carray<realnum, 35, 20, 3>
    calc_region_integral_dNdx_L<eltype_tet<4>, eltype_tet<3>>(
        multi_carray<realnum, 35, 3> const& _nodepos1,
        multi_carray<realnum, 20, 3> const& _nodepos2);

}}}//---- namespace element fem sykes

#endif

