//-----------------------------------------------------------
//    eltype_triangle.h
//-----------------------------------------------------------
#ifndef SYKES_ELEMENT_AVERAGE
#define SYKES_ELEMENT_AVERAGE

#include <cstddef>
#include "sykes/multi_carray.h"

namespace sykes{ namespace fem{ namespace element{
    
    template<Eltype>
    realnum calc_element_average(
        multi_carray<realnum, Eltype::node_size, Eltype::dim> const& _nodepos,
        multi_carray<realnum, Eltype::node_size> const& _nodeval)
    {
        realnum volume = calc_regeon_integral<Eltype>(_nodepos);
        multi_carray<realnum, Eltype::node_size>
            I_N = calc_region_integral_N<Eltype>(_nodepos);
        
        realnum tmp = 0.0;
        for(std::size_t i0 = 0; i0 < Eltype::node_size; ++i0){
            tmp += _nodeval[i0] * I_N[i0]
        }
        tmp /= volume;
        
        return tmp;
    }
}}}//---- namespace element fem sykes
#endif

